/*
  Analog input, analog output, serial output

 Reads an analog input pin, maps the result to a range from 0 to 255
 and uses the result to set the pulsewidth modulation (PWM) of an output pin.
 Also prints the results to the serial monitor.

 The circuit:
 * potentiometer connected to analog pin 0.
   Center pin of the potentiometer goes to the analog pin.
   side pins of the potentiometer go to +5V and ground
 * LED connected from digital pin 9 to ground

 created 29 Dec. 2008
 modified 9 Apr 2012
 by Tom Igoe

 This example code is in the public domain.

 */

// These constants won't change.  They're used to give names
// to the pins used:

short int  D0 = 12,  D1=7,  D2=3;
unsigned long int i=0,j=0,sec;
static short int isdata=0,isrunning=0;
union{
unsigned char ADb[4096];
unsigned int  ADi[1024];
}DAT;
short int ch0,ch1;
short int ch,k, d=0;

void setup() {
  // initialize serial communications at 19200 bps:
  //#define SERIAL_BUFFER_SIZE 256
  SerialUSB.begin(115200);
  analogReadResolution(12);
  pinMode(D0, INPUT);
  pinMode(D1, OUTPUT);
  pinMode(D2, OUTPUT);
  digitalWrite(D1,HIGH);

  for(k=0;k<1024;k++)DAT.ADi[k]=0;
  REG_ADC_MR = (REG_ADC_MR & 0xFFF0FFFF) | 0x00020000;
  //analogReadResolution(12); 
}

void loop() {
  // read the analog in value:
  if(SerialUSB.available()){
    if(isrunning==1)detachInterrupt(D0);
    processSyncMessage();
    if(isrunning==1)attachInterrupt(digitalPinToInterrupt(D0), increment, RISING);  
  }
    if(isdata==1){
    if(d++>4)d=0;  
    ch0 = analogRead(A0);
    ch1 = analogRead(A2);   
    digitalWrite(D1,LOW);  
    ch=(ch0+ch1+d)>>3;
    if((ch>0)&&(ch<1023))DAT.ADi[ch]++;
    DAT.ADi[0]++;
    digitalWrite(D1,HIGH);
    isdata=0;
    digitalWrite(D2,LOW);
    }
    
}

void increment()
{ 
digitalWrite(D2,HIGH);
isdata=1;
}


void processSyncMessage() {
  int k=0;
  char c=0;
  while(SerialUSB.available() > 0){
    c = SerialUSB.read();
    if(c == 'Z'){
      digitalWrite(D1,LOW);
      for(k=0;k<1024;k++)DAT.ADi[k]=0;
      digitalWrite(D1,HIGH);
      isdata=0;
    }
    if(c == 'N'){
      SerialUSB.write(DAT.ADb,4096);
    }
    if(c == 'R'){
      attachInterrupt(digitalPinToInterrupt(D0),  increment,  RISING);
      digitalWrite(D1,LOW); 
      isrunning=1;
      isdata=0;
      digitalWrite(D1,HIGH);
    }
    if(c == 'S'){
      detachInterrupt(D0);
      digitalWrite(D1,LOW); 
      isrunning=0;
      isdata=0;
      digitalWrite(D1,HIGH);
    }
  }
}


